/**
 * @file OpenGlMain
 * 
 * This is a sample to test the Viewer3D
 */

#include <stdio.h>

#include <unistd.h>
#include <GL/glut.h>
#include <pthread.h>
#include <math.h>
#include "viewer3D.h"
#include "robotConfig.h"

int main(int argc, char **argv) { 
  RobotConfigSimu config;
  
  Viewer3D world_(&config);	
  printf("-- Coupe de Robotique 2004 -- \n\nProjet en OpenGL\n"); 
 
  Obstacle obs1(Point(900,1000), Point(1000,1000), 0, 100., 10000);
  ListOfObstacles obstacles;
  obstacles.push_back(obs1);
  world_.setObstacleList(obstacles);

  int x=200, y=200;
  double t=M_PI/4;
  Millisecond time=0;
  Millisecond deltaTime=20;
  while(x<300) {
    world_.setRobotPosition(x,y,t);
    x+=2; y+=2;
    usleep(20000);
    time+=deltaTime;
    world_.updateDisplay(time);
  }
  while(1) {
    while(t>0) {
      world_.setRobotPosition(x,y,t);
      t-=M_PI/100;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(x<2700) {
      world_.setRobotPosition(x,y,t);
      x+=10;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(t<M_PI/2) {
      world_.setRobotPosition(x,y,t);
      t+=M_PI/100;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(y<1800) {
      world_.setRobotPosition(x,y,t);
      y+=10;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(t<M_PI) {
      world_.setRobotPosition(x,y,t);
      t+=M_PI/100;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(x>300) {
      world_.setRobotPosition(x,y,t);
      x-=10;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(t<3*M_PI/2) {
      world_.setRobotPosition(x,y,t);
      t+=M_PI/100;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    while(y>300) {
      world_.setRobotPosition(x,y,t);
      y-=10;
      usleep(20000);
      time+=deltaTime;
      world_.updateDisplay(time);
    }
    printf("Time=%f s\n", (float)(time/1000.));
    world_.setCoveredZoneEraseTime(30000);
  }
}
