#ifndef __LOG_PLAYER_H__
#define __LOG_PLAYER_H__

#include "../viewer3D/texture.h"
#include "viewer3D.h"

void initPlayerControl(int winId, Viewer3D* viewer);
void displayPlayerControl();
void reshapePlayerControl(int w, int h);
void keyboardPlayerControl(unsigned char key, int x, int y);
void menuPlayerControl(int value);
void mousePlayerControl(int button, int state, int x, int y);

typedef enum ControlButtonId{
  CTRL_BTN_PREVIOUS,
  CTRL_BTN_STEP_BACKWARD,
  CTRL_BTN_PLAY,
  CTRL_BTN_STEP_FORWARD,
  CTRL_BTN_NEXT,
  CTRL_BTN_SLOWER,
  CTRL_BTN_FASTER,
  CTRL_BTN_RECORD,

  CTRL_BTN_NBR
} ControlButtonId;

void playerControlRecordBtnCB(ControlButtonId btn, void (*clickCB)());
void playerControlSetBtnEnable(ControlButtonId btn, bool enable);
void playerControlSetBtnTexture(ControlButtonId btn, 
				TextureId t1, 
				TextureId t2);
void playerControlSetTimes(Millisecond realTime, 
			   Millisecond matchTime,
			   const char* info);

#endif // __LOG_PLAYER_H__
