#include <stdio.h>
#include <GL/glut.h>

#include "map.h"
#include "gltools.h"

void drawBG() {
	glLoadIdentity();
	glClear (GL_COLOR_BUFFER_BIT);// Reset The Modelview Matrix
	glClear (GL_DEPTH_BUFFER_BIT);// Reset The Modelview Matrix
	int i,j;
	glColor3f(1.0f,1.0f,1.0f);								// Set Player Color To Light Green
	glBegin(GL_LINES);
		glVertex2d(5,5);	
		glVertex2d(5,215);									// Bottom Right Of Player
		glVertex2d(305,215);									// Top Right Of Player
		glVertex2d(305,5);									// Bottom Left Of Player
		glVertex2d(5,5);	
		glVertex2d(305,5);									// Bottom Right Of Player
		glVertex2d(5,215);									// Top Right Of Player
		glVertex2d(305,215);									// Bottom Left Of Player
	glEnd();			// Done Drawing The Player
	for(i=0;i<10;++i) {
	for(j=0;j<7;++j) {
	if ((i+j)%2==0) continue;
	glBegin(GL_QUADS);										// Start Drawing Our Player Using Lines
		glVertex2d(5+i*30,5+j*30);									// Top Left Of Player
		glVertex2d(5+i*30,5+(j+1)*30);									// Bottom Right Of Player
		glVertex2d(5+(i+1)*30,5+(j+1)*30);									// Top Right Of Player
		glVertex2d(5+(i+1)*30,5+j*30);									// Bottom Left Of Player
	glEnd();			// Done Drawing The Player
	}
	}
	glColor3f(0.0f,1.0f,0.0f);
	glPrint(5,5,1,"GAME OVER");
}

void drawCoverZone() {
	glEnable(GL_ALPHA_TEST);
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(0.0f,1.0f,0.0f, 0.5f);
	glBegin(GL_QUADS);										// Start Drawing Our Player Using Lines
		glVertex2d(30,70);									// Top Left Of Player
		glVertex2d(130,70);									// Bottom Right Of Player
		glVertex2d(130,170);									// Top Right Of Player
		glVertex2d(30,170);									// Bottom Left Of Player
	glEnd();			// Done Drawing The Player
	glDisable(GL_ALPHA_TEST);
}

void drawTargetTrajectory() {
	glColor3f(1.0f,1.0f,0.0f);
	glBegin(GL_LINES);										// Start Drawing Our Player Using Lines
		glVertex2d(30,70);									// Top Left Of Player
		glVertex2d(130,70);									// Bottom Right Of Player
	glEnd();			// Done Drawing The Player
}

void drawRealTrajectory() {
	glColor3f(1.0f,0.0f,0.0f);
	glBegin(GL_LINES);										// Start Drawing Our Player Using Lines
		glVertex2d(30,75);									// Top Left Of Player
		glVertex2d(130,75);									// Bottom Right Of Player
	glEnd();			// Done Drawing The Player
}



void initMap(void) {
  glEnable(GL_BLEND);
  glShadeModel (GL_SMOOTH);
  glClearColor (0.0, 0.0, 0.0, 0.0);
  glClear (GL_COLOR_BUFFER_BIT);

  glutCreateMenu (menuMap);
   glutAddMenuEntry ("Camra adapte", 1);
  glutAttachMenu (GLUT_RIGHT_BUTTON);
}


void displayMap(void) {
	drawBG();
	drawCoverZone();
	drawTargetTrajectory();
	drawRealTrajectory();
	glutSwapBuffers() ;
	fprintf(stdout, "Map\n");
}

void keyboardMap (unsigned char key, int x, int y){ 
   switch (key) {
	   case 13:  // enter
         glutPostRedisplay();
         break;
	   case '+': // quicker  
         glutPostRedisplay();
         break;
	   case '-': // slower
         glutPostRedisplay();
         break;
	   case 'p': // pause
         glutPostRedisplay();
         break;
       case 27:   // echap  
         exit(0);
         break;
      default:
         break;
   }
}


void menuMap (int value){

}

void reshapeMap(int w, int h){
   	glViewport(0,0,(GLsizei) w, (GLsizei) h); 
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		//gluOrtho2D(0.0, (GLfloat) 310, (GLfloat) 220);
		glOrtho(0.0f,w,h,0.0f,-1.0f,1.0f);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
}

// timer
void idleMap(void){
	glutPostRedisplay();
	
}
