#ifndef __TEXTURE_H__
#define __TEXTURE_H__

#include <GL/glu.h>
#include "image.h"

typedef enum TextureId{
  TEX_LOGO=0, 
  TEX_LOGO_ISIA,
  TEX_LOGO_ESSI, 
  TEX_LOGO_ESINSA, 
  TEX_ROBOT_SIDE_LEFT,
  TEX_ROBOT_SIDE_RIGHT,
  TEX_ROBOT_FRONT, 
  TEX_ROBOT_BACK, 
  TEX_ROBOT_TOP, 

  TEX_SALLE_SIDE1,
  TEX_SALLE_SIDE2,
  TEX_SALLE_SIDE3,
  TEX_SALLE_SIDE4,
  TEX_SALLE_PLAFOND,

  TEX_BTN_PREV_0,
  TEX_BTN_PREV_1,
  TEX_BTN_PLAY_0,
  TEX_BTN_PLAY_1,
  TEX_BTN_STEP_FORWARD_0,
  TEX_BTN_STEP_FORWARD_1,
  TEX_BTN_STEP_BACKWARD_0,
  TEX_BTN_STEP_BACKWARD_1,
  TEX_BTN_PAUSE_0,
  TEX_BTN_PAUSE_1,
  TEX_BTN_NEXT_0,
  TEX_BTN_NEXT_1,
  TEX_BTN_FASTER_0,
  TEX_BTN_FASTER_1,
  TEX_BTN_SLOWER_0,
  TEX_BTN_SLOWER_1,
  TEX_BTN_REC_START_0,
  TEX_BTN_REC_START_1,
  TEX_BTN_REC_STOP_0,
  TEX_BTN_REC_STOP_1,

  TEX_NBR
} TextureId;

class Texture{
 private:
  static Image image[TEX_NBR];

 private:
  void loadImage(TextureId texnbr, const char* filename);
  void loadImageBmp(TextureId texnbr, const char* filename);
  void loadImageJpg(TextureId texnbr, const char* filename);
  void loadImageTga(TextureId texnbr, const char* filename);
  bool texMapScalePow2(TextureId texnbr);
  void drawPixels(TextureId texnbr);

 public:
  Texture();
  ~Texture();
  void init();
  void apply(TextureId texnbr);
  void disable(){ glDisable(GL_TEXTURE_2D); }

  static void screenShot(const char* filename);
};
#endif
